using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SSK.SSKClient.SSKForms;
using SSK.SSKClient.UIHelper;
using SSK.SSKClient.ClientStorage;

namespace $safeprojectname$
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void BuyNowButton_Click(object sender, EventArgs e)
		{
			try
			{
				BuyNowForm buyMe = new BuyNowForm();
				buyMe.ShowDialog();
			}
			catch (DataStoreAppConfigException datStoreAppConfigException)
			{
				//Form cannot be used until the datstore has been initialized.
			}
		}

		private void RegisterButton_Click(object sender, EventArgs e)
		{
			try
			{
				RegisterForm register = new RegisterForm();
				register.ShowDialog();
			}
			catch (DataStoreAppConfigException datStoreAppConfigException)
			{
				//Form cannot be used until the datstore has been initialized.
			}
		}

		private void SubmitFeedbackButton_Click(object sender, EventArgs e)
		{
			try
			{
				FeedbackForm feedback = new FeedbackForm();
				feedback.ShowDialog();
			}
			catch (DataStoreAppConfigException datStoreAppConfigException)
			{
				//Form cannot be used until the datstore has been initialized.
			}
		}

		private void ErrorReportButton_Click(object sender, EventArgs e)
		{
			string exceptionNullTest = null;
			try
			{
				//try and check the length without initializing the string to throw
				//an exception for testing
				if (exceptionNullTest.Length > 0)
				{

				}
			}
			//catch the exception to display the exception form
			catch (Exception ex)
			{
				try
				{
					ExceptionForm exForm = new ExceptionForm(ex.Message,
												 ex.Source,
												 ex.StackTrace,
												 "simulateExceptionButton_Click");
					exForm.ShowDialog(this);
				}
				catch (DataStoreAppConfigException datStoreAppConfigException)
				{
					//Form cannot be used until the datstore has been initialized.
				}
			}
		}

		private void VerifyLicensingButton_Click(object sender, EventArgs e)
		{
			DataStore ds = new DataStore(this);
			string displayText;

			displayText = "Product State: " + ds.GetProductState.ToString() + "\r\n\r\n\r\n";
			displayText += "Product License Level: " + ds.GetLicenseLevel.LicenseLevel + " " + ds.GetLicenseLevel.LicenseLevelID.ToString() + "\r\n\r\n\r\n";
			displayText += "Is User Registered: " + ds.UserRegistered.ToString() + "\r\n\r\n\r\n";
			try
			{
				displayText += "Trial Days Elapsed: " + ds.DaysElapsedSinceInstall.ToString() + "\r\n\r\n\r\n";
			}
			catch (DataStoreChronologyException ex)
			{
				displayText += ex.Message;
			}
			MessageBox.Show(this, displayText);
		}
	}
}