
using System;
using System.Web;
using System.Collections;
using System.Configuration;
using System.Xml;
using System.Xml.Serialization;
using System.IO;
using System.Text;
using System.Runtime.Serialization;
using System.Web.Services;
using System.Web.Services.Protocols;

using SSK.Client.License;


namespace SSK.Server
{

    #region Data Classes (and contracts)
    //   [DataContract]
    public class LicenseLevelsPrice
    {
        public LicenseLevelsPrice() { }

        private string _licenseLevel;
        private double _licenseLevelPrice;
        private int _licenseLevelID;
        private bool _isTrialLicenseKey;
        private string _description;

        //   [DataMember]
        public string Description
        {
            get { return _description; }
            set { _description = value; }
        }

        //   [DataMember]
        public int LicenseLevelID
        {
            get { return _licenseLevelID; }
            set { _licenseLevelID = value; }
        }

        //   [DataMember]
        public bool IsTrialLicensekey
        {
            get { return _isTrialLicenseKey; }
            set { _isTrialLicenseKey = value; }
        }

        //   [DataMember]
        public string LicenseLevel
        {
            get { return _licenseLevel; }
            set { _licenseLevel = value; }
        }

        //   [DataMember]
        public double LicenseLevelPrice
        {
            get { return _licenseLevelPrice; }
            set { _licenseLevelPrice = value; }
        }

    }

    //   [DataContract]
    public class PaymentSettings
    {
        public PaymentSettings() { }

        private string _payPalAccountEmail;
        private string _payPalItemNumber;
        private int _payPalQuantity;
        private string _payPalCurrencyCode;
        private string _payPalNotifyURL;
        private Boolean _payPalRequireShippingAddress;
        private Boolean _payPalIncludeNote;
        private string _payPalLogoURL;
        private string _payPalTag;
        private string _payPalNoteTitle;
        private string _payPalSuccessURL;
        private string _payPalCancelURL;
        private string _PaymentURL;

        //   [DataMember]
        public string PayPalAccountEmail
        {
            get { return _payPalAccountEmail; }
            set { _payPalAccountEmail = value; }
        }

        //   [DataMember]
        public string PayPalItemNumber
        {
            get { return _payPalItemNumber; }
            set { _payPalItemNumber = value; }
        }

        //   [DataMember]
        public int PayPalQuantity
        {
            get { return _payPalQuantity; }
            set { _payPalQuantity = value; }
        }

        //   [DataMember]
        public string PayPalCurrencyCode
        {
            get { return _payPalCurrencyCode; }
            set { _payPalCurrencyCode = value; }
        }

        //   [DataMember]
        public string PayPalNotifyURL
        {
            get { return _payPalNotifyURL; }
            set { _payPalNotifyURL = value; }
        }

        //   [DataMember]
        public Boolean PayPalRequireShippingAddress
        {
            get { return _payPalRequireShippingAddress; }
            set { _payPalRequireShippingAddress = value; }
        }

        //   [DataMember]
        public Boolean PayPalIncludeNote
        {
            get { return _payPalIncludeNote; }
            set { _payPalIncludeNote = value; }
        }

        //   [DataMember]
        public string PayPalLogoURL
        {
            get { return _payPalLogoURL; }
            set { _payPalLogoURL = value; }
        }

        //   [DataMember]
        public string PayPalTag
        {
            get { return _payPalTag; }
            set { _payPalTag = value; }
        }

        //   [DataMember]
        public string PayPalNoteTitle
        {
            get { return _payPalNoteTitle; }
            set { _payPalNoteTitle = value; }
        }

        //   [DataMember]
        public string PayPalSuccessURL
        {
            get { return _payPalSuccessURL; }
            set { _payPalSuccessURL = value; }
        }

        //   [DataMember]
        public string PayPalCancelURL
        {
            get { return _payPalCancelURL; }
            set { _payPalCancelURL = value; }
        }

        //   [DataMember]
        public string PaymentURL
        {
            get { return _PaymentURL; }
            set { _PaymentURL = value; }
        }

    }

    //   [DataContract]
    public class DataStore
    {
        public DataStore() { }

        //private string _devToken;
        private DateTime _dateTime;
        //private string _productName;
        private string _licenseLevel;
        private int _numberOfTrialDaysElapsed;
        private DateTime _startDate;
        private Boolean _userInfoRegistered;
        private string _uniqueMachineID;
        private string _registrationKey;
        private bool _refreshDataStore;

        //   [DataMember]
        public string RegistrationKey
        {
            get { return _registrationKey; }
            set { _registrationKey = value; }
        }

        /*//   [DataMember]
        public string DevToken
        {
            get { return _devToken; }
            set { _devToken = value; }
        }*/

        //   [DataMember]
        public DateTime DateTime
        {
            get { return _dateTime; }
            set { _dateTime = value; }
        }

        /*//   [DataMember]
        public string ProductName
        {
            get { return _productName; }
            set { _productName = value; }
        }*/

        //   [DataMember]
        public string LicenseLevel
        {
            get { return _licenseLevel; }
            set { _licenseLevel = value; }
        }

        //   [DataMember]
        public int NumberOfTrialDaysElapsed
        {
            get { return _numberOfTrialDaysElapsed; }
            set { _numberOfTrialDaysElapsed = value; }
        }

        //   [DataMember]
        public DateTime StartDate
        {
            get { return _startDate; }
            set { _startDate = value; }
        }

        //   [DataMember]
        public Boolean UserInfoRegistered
        {
            get { return _userInfoRegistered; }
            set { _userInfoRegistered = value; }
        }

        //   [DataMember]
        public String UniqueMachineID
        {
            get { return _uniqueMachineID; }
            set { _uniqueMachineID = value; }
        }

        //   [DataMember]
        public Boolean RefreshDataStore
        {
            get { return _refreshDataStore; }
            set { _refreshDataStore = value; }
        }
    }

    //   [DataContract]
    public class ClientAppConfig
    {
        public ClientAppConfig() { }

        private int _buyNowMaxNumPoll;
        private string _productName;
        private int _activateNowMaxNumPoll;
        private int _trialLengthDays;
        private int _abortTimerLength;
        private int _pollingTimerLength;
        private string _devToken;
        private string _serverPublicKey;
        private LicenseLevelsPrice[] _licenseLevelPrices;
        private PaymentSettings _paymentSettings;
        private DataStore _dataStoreSettings;
        

        //   [DataMember]
        public DataStore DataStoreSettings
        {
            get { return _dataStoreSettings; }
            set { _dataStoreSettings = value; }
        }

        //   [DataMember]
        public int BuyNowMaxNumPoll
        {
            get { return _buyNowMaxNumPoll; }
            set { _buyNowMaxNumPoll = value; }
        }

        //   [DataMember]
        public int ActivateNowMaxNumPoll
        {
            get { return _activateNowMaxNumPoll; }
            set { _activateNowMaxNumPoll = value; }
        }

        //   [DataMember]
        public int TrialLengthDays
        {
            get { return _trialLengthDays; }
            set { _trialLengthDays = value; }
        }

        //   [DataMember]
        public int AbortTimerLength
        {
            get { return _abortTimerLength; }
            set { _abortTimerLength = value; }
        }

        //   [DataMember]
        public int PollingTimerLength
        {
            get { return _pollingTimerLength; }
            set { _pollingTimerLength = value; }
        }

        //   [DataMember]
        public string DevToken
        {
            get { return _devToken; }
            set { _devToken = value; }
        }

        //   [DataMember]
        public string ServerPublicKey
        {
            get { return _serverPublicKey; }
            set { _serverPublicKey = value; }
        }

        //   [DataMember]
        public LicenseLevelsPrice[] LicenseLevelPrices
        {
            get { return _licenseLevelPrices; }
            set { _licenseLevelPrices = value; }
        }

        //   [DataMember]
        public PaymentSettings PaymentSettings
        {
            get { return _paymentSettings; }
            set { _paymentSettings = value; }
        }

        //   [DataMember]
        public string ProductName
        {
            get { return _productName; }
            set { _productName = value; }
        }


    }
    #endregion


    /// <summary>
    /// Summary description for ServiceImpl
    /// </summary>
    public class SharewareServiceImpl
    {
        private Logger logger = new Logger(ConfigurationManager.AppSettings["loggingPath"], "SharewareServiceLog.txt");

        /// <summary>
        /// Returns a string that is limited in length.  Used to prevent
        /// SQL overruns when using arguments for SQL statements.
        /// </summary>
        /// <param name="str">Source string</param>
        /// <param name="cutLength">Length of resulting string</param>
        /// <returns>Source string limited to cutLength characters</returns>
        private string CutString(string str, int cutLength)
        {

            if (str.Length > cutLength)
                return str.Substring(0, cutLength);
            else
                return str;
        }

        /// <summary>
        /// Used to pull out the contents of a LicenseRequest object.
        /// </summary>
        /// <param name="licenseRequest">Source LicenseRequest object</param>
        /// <param name="product">out param - Product Name</param>
        /// <param name="clientIdentity">out param - Client Identity String</param>
        /// <param name="licenseLevel">out param - LicenseLevel string</param>
        private void CrackLicenseRequest(LicenseRequest licenseRequest, out string product, out string clientIdentity, out string licenseLevel)
        {
            clientIdentity = licenseRequest.ClientIdentity;

            // LicenseLevels - convert from enum to string
            licenseLevel = licenseRequest.LicenseLevel;

            // Product - string
            product = licenseRequest.Product;
        }

        /// <summary>
        /// RegisterUser allows a Shareware Starter Kit
        /// application (client) to register a user for software 
        /// and information updates with the shareware developer.
        /// This information is also referenced on the server 
        /// for other actions done by the client user.  This method 
        /// validates input for SQL processing and uses the database
        /// helper class to access/read the database.  If the required 
        /// parameters are not entered a ArgumentNullException is
        /// thrown.
        /// </summary>
        /// <param name="lastname">Required: Last name </param>
        /// <param name="firstname">Required: First name </param>
        /// <param name="address">Address</param>
        /// <param name="city">City</param>
        /// <param name="state">State</param>
        /// <param name="zip">Zip code (##### or #####-####)</param>
        /// <param name="phone">Phone ((###) ###-####)</param>
        /// <param name="email">Required: Email (name@server.com)</param>
        /// <returns></returns>
        public Boolean RegisterUser(string lastname,		// required
            string firstname,							// required
            string address,
            string city,
            string state,
            string zip,
            string phone,
            string email,							    // required 						
            string devToken,
            string productName,
            string uniqueMachineID,
            string licenseLevel
            )                               // required
        {

            Logger.Log("RegisterUser : Beginning : DevToken = " + devToken + " : UniqueMachineID = " + uniqueMachineID);

            #region parameter validation
            try
            {
                Logger.Log("RegisterUser : Parameter Validation : Beginning");

                // Parameter Validation - throws an exception if the required fields
                // are not provided.
                if ((lastname == null) || (lastname == ""))
                    throw new ArgumentNullException("lastname",
                        "Reason: 'lastname is a required parameter'");

                if ((firstname == null) || (firstname == ""))
                    throw new ArgumentNullException("firstname",
                        "Reason: 'firstname is a required argument'");

                if ((email == null) || (email == ""))
                    throw new ArgumentNullException("email",
                        "Reason: 'email is a required parameter'");

                if ((devToken == null) || (devToken == ""))
                    throw new ArgumentNullException("devToken",
                        "Reason: 'devToken is a required parameter'");

                if ((productName == null) || (productName == ""))
                    throw new ArgumentNullException("productName",
                        "Reason: 'productName is a required parameter'");

                if ((uniqueMachineID == null) || (uniqueMachineID == ""))
                    throw new ArgumentNullException("uniqueMachineID",
                        "Reason: 'uniqueMachineID is a required parameter'");

                if ((licenseLevel == null) || (licenseLevel == ""))
                    throw new ArgumentNullException("licenseLevel",
                        "Reason: 'licenseLevel is a required parameter'");

                Logger.Log("RegisterUser : Parameter Validation : Complete");
            }
            catch (ArgumentNullException argNullEx)
            {
                Logger.Log("RegusterUser : Parameter Validation : Exception : " + argNullEx.Message);
                throw argNullEx;
            }
            #endregion

            #region string length validation
            try
            {
                Logger.Log("RegusterUser : Guarantee the length of these strings : Beginning");

                // Guarantee the length of these strings.
                lastname = CutString(lastname, 32);
                firstname = CutString(firstname, 32);
                address = CutString(address, 128);
                city = CutString(city, 32);
                state = CutString(state, 32);
                zip = CutString(zip, 32);
                phone = CutString(phone, 32);
                email = CutString(email, 32);
                devToken = CutString(devToken, 256);
                productName = CutString(productName, 256);
                uniqueMachineID = CutString(uniqueMachineID, 512);
                licenseLevel = CutString(licenseLevel, 256);

                Logger.Log("RegusterUser : Guarantee the length of these strings : Completed.");
            }
            catch (Exception ex)
            {
                Logger.Log("RegusterUser : Guarantee the length of these strings : Exception : " + ex.Message);
                throw new SharewareServerException("Reason: 'An error occurred while validating the length of user data.'", ex);
            }
            #endregion

            DBHelper db = new DBHelper();

            #region validate arguments for SQL
            try
            {

                Logger.Log("RegusterUser : ValidateArgForSQL : Beginning.");

                // Check all input for SQL Insertion attack.
                db.ValidateArgForSQL(ref lastname);
                db.ValidateArgForSQL(ref firstname);
                db.ValidateArgForSQL(ref address);
                db.ValidateArgForSQL(ref city);
                db.ValidateArgForSQL(ref state);
                db.ValidateArgForSQL(ref zip);
                db.ValidateArgForSQL(ref phone);
                db.ValidateArgForSQL(ref email);
                db.ValidateArgForSQL(ref devToken);
                db.ValidateArgForSQL(ref productName);
                db.ValidateArgForSQL(ref uniqueMachineID);
                db.ValidateArgForSQL(ref licenseLevel);

                Logger.Log("RegusterUser : ValidateArgForSQL : Completed.");
            }
            catch (Exception ex)
            {
                Logger.Log("RegusterUser : ValidateArgForSQL : Exception : " + ex.Message);
                throw new SharewareServerException("Reason: 'An error occurred while validating the user data for SQL requirements.'", ex);
            }
            #endregion

            #region Add user info to db
            try
            {
                Logger.Log("RegusterUser : AddUser: Beginning");

                // Insert the record using the Database helper object
                db.AddUser(lastname, firstname, address, city, state,
                    zip, phone, email, devToken, productName, licenseLevel, uniqueMachineID);

                Logger.Log("RegusterUser : AddUser : Completed");
            }
            catch (Exception ex)
            {
                Logger.Log("RegusterUser : AddUser : Exception : " + ex.Message);
                throw new SharewareServerException("Reason: 'An error occurred while entering user data into the database. Error: " +
                    ex.Message + "'", ex);
            }
            #endregion

            #region update user registration status in db and return value
            try
            {
                Logger.Log("RegusterUser : UpdateDataStoreRegistration : Beginning");

                //update the server side datastore with the registration information
                if (db.UpdateDataStoreRegistration(devToken, productName, uniqueMachineID, true) > 0)
                {
                    Logger.Log("RegusterUser : UpdateDataStoreRegistration : Completed: True");
                    Logger.Log("RegusterUser : Completed : DevToken = " + devToken + " : UniqueMachineID = " + uniqueMachineID);
                    return true;
                }
                else
                {
                    Logger.Log("RegusterUser : UpdateDataStoreRegistration : Completed: False");
                    Logger.Log("RegusterUser : Completed : DevToken = " + devToken + " : UniqueMachineID = " + uniqueMachineID);
                    return false;
                }
            }
            catch (Exception ex)
            {
                Logger.Log("RegusterUser : UpdateDataStoreRegistration : Exception : " + ex.Message + " : DevToken = " + devToken + " : UniqueMachineID = " + uniqueMachineID);
                throw new SharewareServerException("Reason: 'An error occurred while updating the registration status.'", ex);
            }
            #endregion


        }

        /// <summary>
        /// GetLicense is the WebMethod that implements the Buy Now experience on
        /// the Shareware Starter Kit Server.  The client application calls this
        /// method to request a LicenseResponse object.
        /// </summary>
        /// 
        /// <param name="licenseRequest">
        /// LicenseRequest object which contains
        /// Product Name, Client Identify, and License Level
        /// </param>
        /// 
        /// <param name="invoice"> 
        /// Invoice is an identifier created on the client
        /// for future referencing.
        /// </param>
        /// 
        /// <returns>
        /// A LicenseResponse object if the Invoice ID is able to give 
        /// licenses or NULL if not.
        /// </returns>
        public string GetLicense(string product, string clientIdentity,
            string licenseLevel, string invoice, string devToken,
            string clientSerialId)
        {

            Logger.Log("GetLicense : Beginning");

            LicenseRequest licenseRequest = new LicenseRequest();
            licenseRequest.Product = product;
            licenseRequest.ClientIdentity = clientIdentity;
            licenseRequest.LicenseLevel = licenseLevel;

            #region parameter validation
            try
            {

                Logger.Log("GetLicense : Parameter Validation : Beginning : DevToken = " + devToken + " : clientSerialId = " + clientSerialId);

                if (invoice == null || invoice == "")
                    throw new ArgumentNullException("invoice", "Invoice must not be null");

                if (devToken == null || devToken == "")
                    throw new ArgumentNullException("devID", "devToken must not be null");

                if (clientSerialId == null || clientSerialId == "")
                    throw new ArgumentNullException("clientSerialId", "clientSerialId must not be null");



                if (licenseRequest.Product == null || licenseRequest.Product == "")
                {
                    throw new ArgumentNullException("licenseRequest.product", "licenseRequest.product must not be null");
                }
                else
                {
                    product = licenseRequest.Product;
                }

                if (licenseRequest.ClientIdentity == null || licenseRequest.ClientIdentity == "")
                {
                    throw new ArgumentNullException("licenseRequest.clientIdentity", "clientIdentity must not be null");
                }
                else
                {
                    clientIdentity = licenseRequest.ClientIdentity;
                }

                if (licenseRequest.LicenseLevel == null)
                {
                    licenseLevel = "";
                    licenseRequest.LicenseLevel = "";
                }
                else
                {
                    licenseLevel = licenseRequest.LicenseLevel;
                }


                Logger.Log("GetLicense : Parameter Validation : Complete");
            }
            catch (ArgumentNullException argNullEx)
            {
                Logger.Log("GetLicense : Parameter Validation : Exception : " + argNullEx.Message);
                throw argNullEx;
            }
            #endregion

            #region string length validation
            try
            {
                Logger.Log("GetLicense : Guarantee the length of these strings : Beginning");

                invoice = CutString(invoice, 256);
                devToken = CutString(devToken, 256);
                clientSerialId = CutString(clientSerialId, 256);
                clientIdentity = CutString(clientIdentity, 512);
                product = CutString(product, 256);
                licenseLevel = CutString(licenseLevel, 256);

                Logger.Log("GetLicense : Guarantee the length of these strings : Completed.");
            }
            catch (Exception ex)
            {
                Logger.Log("GetLicense : Guarantee the length of these strings : Exception : " + ex.Message);
                throw new SharewareServerException("Reason: 'An error occurred while validating the length of user data.'", ex);
            }
            #endregion

            DBHelper db = new DBHelper();

            #region validate arguments for SQL
            try
            {

                Logger.Log("GetLicense : ValidateArgForSQL : Beginning.");

                // Check all input for SQL Insertion attack.
                db.ValidateArgForSQL(ref invoice);
                db.ValidateArgForSQL(ref devToken);
                db.ValidateArgForSQL(ref clientSerialId);
                db.ValidateArgForSQL(ref clientIdentity);
                db.ValidateArgForSQL(ref product);
                db.ValidateArgForSQL(ref licenseLevel);

                Logger.Log("GetLicense : ValidateArgForSQL : Completed.");
            }
            catch (Exception ex)
            {
                Logger.Log("GetLicense : ValidateArgForSQL : Exception : " + ex.Message);
                throw new SharewareServerException("Reason: 'An error occurred while validating the user data for SQL requirements.'", ex);
            }
            #endregion



            //Logger.Log("GetLicense : CrackLicenseRequest : Beginning");
            // Pull out the data from the LicenseRequest object
            //CrackLicenseRequest(licenseRequest, out product, out clientIdentity, out licenseLevel);
            //Logger.Log("GetLicense : CrackLicenseRequest : Completed");

            try
            {
                Logger.Log("GetLicense : StoreLicenseTransaction : Beginning");

                try
                {
                    // Store the licenseRequest (clientIdentity, licenseLevel,
                    // product) and invoice number in the LicenseTransaction 
                    // table.
                    db.StoreLicenseTransaction(clientIdentity,
                        licenseLevel,
                        product,
                        invoice,
                        devToken,
                        clientSerialId);
                }
                catch (Exception ex)
                {
                    Logger.Log("GetLicense : StoreLicenseTransaction : Exception : " + ex.Message);
                    throw ex;
                }

                Logger.Log("GetLicense : StoreLicenseTransaction : Completed");


                // Call into the DB Helper class to find if the invoice can give the 
                // client a License.
                Logger.Log("GetLicense : VerifyLicenseAvailableInDB : Beginning");
                if (db.VerifyLicenseAvailableInDB(clientIdentity, ref licenseLevel, product, invoice, devToken))
                {
                    Logger.Log("GetLicense : VerifyLicenseAvailableInDB : True");

                    LicenseServer server = new LicenseServer();

                    //if the license level is null then set it to the reference of the local licenseLevel
                    //this is for the activate now feature where the license level is not sent up from the client
                    if (licenseRequest.LicenseLevel == null || licenseRequest.LicenseLevel == "")
                    {
                        licenseRequest.LicenseLevel = licenseLevel;
                    }

                    // Build a LicenseResponse for the client since the invoice is valid.
                    Logger.Log("GetLicense : CreateLicenseReponse : Beginning");
                    LicenseResponse response = server.CreateLicenseReponse(licenseRequest);
                    Logger.Log("GetLicense : CreateLicenseReponse : Completed");

                    // Store the licenseRequest.GetAuthenticatedLicenseAsString() in the
                    // LicenseTransaction table
                    Logger.Log("GetLicense : StoreAuthLicense : Beginning");
                    db.StoreAuthLicense(clientIdentity, invoice, response.GetAuthenticatedLicenseAsString());
                    Logger.Log("GetLicense : StoreAuthLicense : Completed");

                    //update the SSK_Datastore table with the approved registration key
                    Logger.Log("GetLicense : UpdateDataStoreRegistrationKey : Beginning");
                    db.UpdateDataStoreRegistrationKey(devToken, product, clientSerialId, response.GetAuthenticatedLicenseAsString(), licenseLevel);
                    Logger.Log("GetLicense : UpdateDataStoreRegistrationKey : Completed");

                    //send out an email to the user with their license information
                    SendMail sendUserMail = new SendMail();
                    Logger.Log("GetLicense : SendMailApprovedLicense : Beginning");
                    sendUserMail.SendMailApprovedLicense(invoice, response.GetAuthenticatedLicenseAsString());
                    Logger.Log("GetLicense : SendMailApprovedLicense : Completed");

                    Logger.Log("GetLicense : Completed : License Returned : DevToken = " + devToken + " : clientSerialId = " + clientSerialId +
                        "License Level: " + response.LicenseLevel);

                    StringWriter Output = new StringWriter(new StringBuilder());
                    XmlSerializer xs = new XmlSerializer(typeof(LicenseResponse));
                    xs.Serialize(Output, response);
                    return Output.ToString();
                }

            }
            catch (Exception ex)
            {
                if (typeof(NoAvailableLicensesException) != ex.GetType())
                {
                    Logger.Log("GetLicense: Exception : " + ex.Message);
                    SendMail sendAdminMail = new SendMail();
                    sendAdminMail.Send("SSK WebService Error in Get License", ex.ToString(), ConfigurationManager.AppSettings["AdminEmail"]);
                }

                if (typeof(NoAvailableLicensesException) == ex.GetType())
                {
                    Logger.Log("GetLicense : Exception : NoAvailableLicensesException : " + ex.Message + " : DevToken = " + devToken + " : clientSerialId = " + clientSerialId);
                    throw (ex);
                }
                else
                {
                    // Exercise - Log the expeptions at this level to the database
                    Logger.Log("GetLicense : Exception : Unknown : " + ex.Message + " : DevToken = " + devToken + " : clientSerialId = " + clientSerialId);
                    throw new SharewareServerException("Reason: 'An error occurred while generating the product activation license.'", ex);
                }

            }

            // If we got here, we found no reference to this invoice in the transaction 
            // or coupon tables.
            Logger.Log("GetLicense : Completed : NULL License Returned : DevToken = " + devToken + " : clientSerialId = " + clientSerialId);
            return null;
        }

        /// <summary>
        /// SubmitIssue allows a client application to send an issue to the
        /// Shareware Server.
        /// 
        /// This method validates input for SQL processing.
        /// Uses the database helper class.
        /// Throws ArgumentNullException for all null or empty paramters.
        /// </summary>
        /// <param name="productName">Name of the product</param>
        /// <param name="licenseLevel">License Level</param>
        /// <param name="emailContact">Email contact (name@server.com)</param>
        /// <param name="firstName">First Name</param>
        /// <param name="lastName">Last Name</param>
        /// <param name="description">Description of the feedback the client
        /// would like to give the server</param>
        public Boolean SubmitIssue(string productName,
            string licenseLevel,
            string emailContact,
            string firstName,
            string lastName,
            string description,
            string devID,
            string uniqueMachineID)
        {
            Logger.Log("SubmitIssue : Beginning");

            #region parameter validation
            try
            {

                Logger.Log("SubmitIssue : Parameter Validation : Beginning : DevToken = " + devID + " : UniqueMachineID = " + uniqueMachineID);

                // Throw an exception for bad arguments
                if ((productName == null) || (productName == ""))
                    throw new ArgumentNullException();

                if ((licenseLevel == null) || (licenseLevel == ""))
                    throw new ArgumentNullException();

                if ((emailContact == null) || (emailContact == ""))
                    throw new ArgumentNullException();

                if ((firstName == null) || (firstName == ""))
                    throw new ArgumentNullException();

                if ((lastName == null) || (lastName == ""))
                    throw new ArgumentNullException();


                if ((devID == null) || (devID == ""))
                    throw new ArgumentNullException();

                if ((uniqueMachineID == null) || (uniqueMachineID == ""))
                    throw new ArgumentNullException();

                Logger.Log("SubmitIssue : Parameter Validation : Complete");
            }
            catch (ArgumentNullException argNullEx)
            {
                Logger.Log("SubmitIssue : Parameter Validation : Exception : " + argNullEx.Message);
                throw argNullEx;
            }
            #endregion

            #region string length validation
            try
            {
                Logger.Log("SubmitIssue : Guarantee the length of these strings : Beginning");

                // Limit the size of the strings
                productName = CutString(productName, 32);
                licenseLevel = CutString(licenseLevel, 32);
                emailContact = CutString(emailContact, 32);
                firstName = CutString(firstName, 32);
                lastName = CutString(lastName, 32);
                description = CutString(description, 1024);
                devID = CutString(devID, 64);
                uniqueMachineID = CutString(uniqueMachineID, 256);
                Logger.Log("SubmitIssue : Guarantee the length of these strings : Completed.");
            }
            catch (Exception ex)
            {
                Logger.Log("SubmitIssue : Guarantee the length of these strings : Exception : " + ex.Message);
                throw new SharewareServerException("Reason: 'An error occurred while validating the length of user data.'", ex);
            }
            #endregion

            DBHelper db = new DBHelper();

            #region validate arguments for SQL
            try
            {

                Logger.Log("SubmitIssue : ValidateArgForSQL : Beginning.");

                // Check all input for SQL Insertion attack.
                db.ValidateArgForSQL(ref productName);
                db.ValidateArgForSQL(ref licenseLevel);
                db.ValidateArgForSQL(ref emailContact);
                db.ValidateArgForSQL(ref firstName);
                db.ValidateArgForSQL(ref lastName);
                db.ValidateArgForSQL(ref description);
                db.ValidateArgForSQL(ref devID);
                db.ValidateArgForSQL(ref uniqueMachineID);
                Logger.Log("SubmitIssue : ValidateArgForSQL : Completed");
            }
            catch (Exception ex)
            {
                Logger.Log("SubmitIssue : ValidateArgForSQL : Exception : " + ex.Message);
                throw new SharewareServerException("Reason: 'An error occurred while validating the user data for SQL requirements.'", ex);
            }
            #endregion

            #region Add user info to db
            try
            {
                Logger.Log("SubmitIssue : SubmitIssue: Beginning");

                // Use the database helper class to write the issue to the database
                if (db.SubmitIssue(productName,
                    licenseLevel,
                    emailContact,
                    firstName,
                    lastName,
                    description,
                    devID,
                    uniqueMachineID) > 0)
                {
                    Logger.Log("SubmitIssue : db.SubmitIssue : Completed : True : DevToken = " + devID + " : UniqueMachineID = " + uniqueMachineID);
                    return true;
                }
                else
                {
                    Logger.Log("SubmitIssue : db.SubmitIssue : Completed : False : DevToken = " + devID + " : UniqueMachineID = " + uniqueMachineID);
                    return false;
                }

            }
            catch (Exception ex)
            {
                Logger.Log("SubmitIssue :  db.SubmitIssue : Exception : " + ex.Message + " : DevToken = " + devID + " : UniqueMachineID = " + uniqueMachineID);
                throw new SharewareServerException("Reason: 'An error occurred while entering user data into the database. Error: " +
                        ex.Message + "'", ex);
            }
            #endregion

        }

        /// <summary>
        /// SubmitException is used by the shareware client to submit
        /// an exception that happened when the shareware user was using
        /// the shareware application.
        /// </summary>
        /// <param name="message">Exception Message</param>
        /// <param name="source">Source filename which threw the exception</param>
        /// <param name="stackTrace">Stack trace at exception</param>
        /// <param name="methodName">Method name which threw the exception</param>
        /// <param name="productName">The name of the product throwing the exception</param>
        public Boolean SubmitException(string message,
            string source,
            string stackTrace,
            string methodName,
            string productName,
            string devToken,
            string uniqueMachineID,
            string licenseLevel)
        {
            Logger.Log("SubmitException : Beginning: DevToken = " + devToken + " : UniqueMachineID = " + uniqueMachineID);

            #region string length validation
            try
            {
                Logger.Log("SubmitException : Guarantee the length of these strings : Beginning");

                //limit the size of all the strings
                message = CutString(message, 1024);
                source = CutString(source, 1024);
                stackTrace = CutString(stackTrace, 1024);
                methodName = CutString(methodName, 128);
                productName = CutString(productName, 128);
                devToken = CutString(devToken, 64);
                uniqueMachineID = CutString(uniqueMachineID, 512);
                licenseLevel = CutString(licenseLevel, 256);
                Logger.Log("SubmitException : Guarantee the length of these strings : Completed.");
            }
            catch (Exception ex)
            {
                Logger.Log("SubmitException : Guarantee the length of these strings : Exception : " + ex.Message);
                throw new SharewareServerException("Reason: 'An error occurred while validating the length of user data.'", ex);
            }
            #endregion

            //the db helper class performs all DB related tasks
            DBHelper db = new DBHelper();

            #region validate arguments for SQL
            try
            {

                Logger.Log("SubmitException : ValidateArgForSQL : Beginning.");

                // Check all input for SQL Insertion attack.
                db.ValidateArgForSQL(ref message);
                db.ValidateArgForSQL(ref source);
                db.ValidateArgForSQL(ref stackTrace);
                db.ValidateArgForSQL(ref methodName);
                db.ValidateArgForSQL(ref productName);
                db.ValidateArgForSQL(ref devToken);
                db.ValidateArgForSQL(ref uniqueMachineID);
                db.ValidateArgForSQL(ref licenseLevel);
                Logger.Log("SubmitException : ValidateArgForSQL : Completed.");
            }
            catch (Exception ex)
            {
                Logger.Log("SubmitException : ValidateArgForSQL : Exception : " + ex.Message);
                throw new SharewareServerException("Reason: 'An error occurred while validating the user data for SQL requirements.'", ex);
            }
            #endregion

            #region Add user info to db
            try
            {
                Logger.Log("SubmitException : db.SubmitException : Beginning");

                //enter the exception into the DB
                if (db.SubmitException(message, source, stackTrace, methodName, productName, devToken, licenseLevel, uniqueMachineID) > 0)
                {
                    Logger.Log("SubmitException : db.SubmitException : Completed : True : DevToken = " + devToken + " : UniqueMachineID = " + uniqueMachineID);
                    return true;
                }
                else
                {
                    Logger.Log("SubmitException : db.SubmitException : Completed : False : DevToken = " + devToken + " : UniqueMachineID = " + uniqueMachineID);
                    return false;
                }
            }
            catch (Exception ex)
            {
                Logger.Log("SubmitException :  db.SubmitException : Exception : " + ex.Message + " : DevToken = " + devToken + " : UniqueMachineID = " + uniqueMachineID);
                throw new SharewareServerException("Reason: 'An error occurred while entering user data into the database. Error: " +
                    ex.Message + "'", ex);
            }
            #endregion
        }

        /// <summary>
        /// GetClientAppConfig is used to return the application configuration setting back to the client
        /// for storage in the local application configuration
        /// </summary>
        public ClientAppConfig GetClientAppConfig(string productName, string devToken, string uniqueMachineID, DateTime startDateTime, string Url)
        {

            Logger.Log("GetClientAppConfig : Beginning : DevToken = " + devToken + " : UniqueMachineID = " + uniqueMachineID);

            #region parameter validation
            try
            {

                Logger.Log("GetClientAppConfig : Parameter Validation : Beginning");

                if ((productName == null) || (productName == ""))
                    throw new ArgumentNullException();

                if ((devToken == null) || (devToken == ""))
                    throw new ArgumentNullException();

                if ((uniqueMachineID == null) || (uniqueMachineID == ""))
                    throw new ArgumentNullException();

                if ((startDateTime == null))
                    throw new ArgumentNullException();
                Logger.Log("GetClientAppConfig : Parameter Validation : Complete");
            }
            catch (ArgumentNullException argNullEx)
            {
                Logger.Log("GetClientAppConfig : Parameter Validation : Exception : " + argNullEx.Message);
                throw argNullEx;
            }
            #endregion

            //the db helper class performs all DB related tasks
            DBHelper db = new DBHelper();

            #region string length validation
            try
            {
                Logger.Log("GetClientAppConfig : Guarantee the length of these strings : Beginning");

                //limit the size of all the strings
                productName = CutString(productName, 256);
                devToken = CutString(devToken, 256);
                uniqueMachineID = CutString(uniqueMachineID, 256);
                Logger.Log("GetClientAppConfig : Guarantee the length of these strings : Completed.");
            }
            catch (Exception ex)
            {
                Logger.Log("GetClientAppConfig : Guarantee the length of these strings : Exception : " + ex.Message);
                throw new SharewareServerException("Reason: 'An error occurred while validating the length of user data.'", ex);
            }
            #endregion

            #region validate arguments for SQL
            try
            {

                Logger.Log("GetClientAppConfig : ValidateArgForSQL : Beginning.");

                // Check all input for SQL Insertion attack.
                db.ValidateArgForSQL(ref productName);
                db.ValidateArgForSQL(ref devToken);
                db.ValidateArgForSQL(ref uniqueMachineID);
                db.ValidateArgForSQL(ref startDateTime);
                Logger.Log("GetClientAppConfig : ValidateArgForSQL : Completed.");
            }
            catch (Exception ex)
            {
                Logger.Log("GetClientAppConfig : ValidateArgForSQL : Exception : " + ex.Message);
                throw new SharewareServerException("Reason: 'An error occurred while validating the user data for SQL requirements.'", ex);
            }
            #endregion

            #region Fill the ClientAppConfigObject
            try
            {
                //return the filled ClientAppConfigObject from the db helper class
                Logger.Log("GetClientAppConfig : db.FillClientAppConfig : Beginning.");
                ClientAppConfig clientAppConfig = db.FillClientAppConfig(productName, devToken, uniqueMachineID, startDateTime, Url);
                Logger.Log("GetClientAppConfig : db.FillClientAppConfig  : Completed.");

                Logger.Log("GetClientAppConfig : Completed : DevToken = " + devToken + " : UniqueMachineID = " + uniqueMachineID);
                return clientAppConfig;
            }
            catch (Exception ex)
            {
                Logger.Log("GetClientAppConfig : db.FillClientAppConfig  : Exception : " + ex.Message + " : DevToken = " + devToken + " : UniqueMachineID = " + uniqueMachineID);
                throw new SharewareServerException("Reason: 'An error occurred while populating the application configuration data.'", ex);
            }
            #endregion

        }

    }


}