using System;
using System.Data;
using System.Configuration;


namespace SSK.Server
{
    public class SharewareServerException : Exception
    {
        public SharewareServerException() { }

        public SharewareServerException(string s) : base(s) { }

        public SharewareServerException(string s, Exception innerE)
            : base(s, innerE) { }
    }

    public class PaypalException : SharewareServerException
    {
        public PaypalException() { }

        public PaypalException(string s) : base(s) { }

        public PaypalException(string s, Exception innerE)
            : base(s, innerE) { }
    }

    public class NotPaidInvoiceAndNotCouponException : SharewareServerException
    {
        public NotPaidInvoiceAndNotCouponException() { }

        public NotPaidInvoiceAndNotCouponException(string s) : base(s) { }

        public NotPaidInvoiceAndNotCouponException(string s, Exception innerE)
            : base(s, innerE) { }
    }

    public class NoAvailableLicensesException : SharewareServerException
    {
        public NoAvailableLicensesException() { }

        public NoAvailableLicensesException(string s) : base(s) { }

        public NoAvailableLicensesException(string s, Exception innerE)
            : base(s, innerE) { }
    }

    /// <summary>
    /// 
    /// </summary>
    public class ArgumentInvalidSQLException : SharewareServerException
    {
        public ArgumentInvalidSQLException() { }

        public ArgumentInvalidSQLException(string s) : base(s) { }

        public ArgumentInvalidSQLException(string s, Exception innerE)
            : base(s, innerE) { }
    }

}
