using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using System.Data.SqlClient;
using System.Configuration;
using Microsoft.ApplicationBlocks.Data;
using SSK.Server;

namespace PayPal.IPN
{
    /// <summary>
    /// Summary description for IpnService.
    /// </summary>
    public class IpnService : System.Web.Services.WebService
    {
        private Logger IpnServiceServerlogger = new Logger(ConfigurationManager.AppSettings["loggingPath"], "SharewareServiceLog.txt");

        /// <summary>
        /// Default constructor.
        /// </summary>
        public IpnService()
        {
            //CODEGEN: This call is required by the ASP.NET Web Services Designer
            InitializeComponent();
          
        }


        #region Component Designer generated code

        //Required by the Web Services Designer 
        private IContainer components = null;

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing && components != null)
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        #endregion

        /// <summary>
        /// Main function that will process the input and place the transaction information into the
        /// database.<see cref="IpnTransaction"/>.
        /// </summary>
        /// <param name="ipnTx">The <see cref="IpnTransaction"/> that represents the IPN message.</param>
        /// <returns>Returns TRUE if processing was successful, otherwise returns FALSE.</returns>
        [WebMethod]
        public bool ProcessTransaction(IpnTransaction ipnTx)
        {
            Logger.Log("IpnService : Beginning");

            System.Decimal ID = 0;

            try
            {
                Logger.Log("IpnService : Insert Into Payment_Transaction : Beginning");
                #region Insert into Payment_Transaction table and get back ID


                ID = (System.Decimal)SqlHelper.ExecuteScalar(ConfigurationManager.AppSettings["SQLConnectionString"],
                        "Payment_Insert_Transaction",
                        System.DateTime.Now,
                        ipnTx.Business,
                        ipnTx.Custom,
                        ipnTx.Invoice,
                        ipnTx.McCurrency,
                        ipnTx.McFee.ToString(),
                        ipnTx.McGross.ToString(),
						ipnTx.Memo,
                        ipnTx.PaymentDate,
                        ipnTx.PaymentStatus,
                        ipnTx.PaymentType,
                        ipnTx.PendingReason,
                        ipnTx.ReceiverEmail,
                        ipnTx.ReceiverID,
                        ipnTx.RecurTimes,
                        ipnTx.SettleAmount,
                        ipnTx.SettleCurrency,
                        ipnTx.Tax,
                        ipnTx.TransactionID,
                        ipnTx.TransactionType);
                #endregion
               Logger.Log("IpnService : Insert Into Payment_Transaction : Completed");
               Logger.Log("IpnService : Insert Into Payment_Transaction_Related : Beginning");
                #region Insert into Payment_Transaction_Related table 
               SqlHelper.ExecuteNonQuery(ConfigurationManager.AppSettings["SQLConnectionString"],
                "Payment_Insert_Transaction_Related",
                Convert.ToInt32(ID),
                ipnTx.ExchangeRate,
                ipnTx.IPNVersion,
                ipnTx.IsRecurring,
                ipnTx.Option1FieldName,
                ipnTx.Option1Selection,
                ipnTx.Option2FieldName,
                ipnTx.Option2Selection,
                ipnTx.Password,
                ipnTx.RawIPN,
                ipnTx.ReasonCode,
                ipnTx.ReattemptFailedPayments,
                ipnTx.RetryFailedPaymentsDate,
                ipnTx.Username,
                ipnTx.VerifySign);
         #endregion
                Logger.Log("IpnService : Insert Into Payment_Transaction_Related : Completed");
                Logger.Log("IpnService : Insert Into Payment_CustInfo: Beginning");
                #region insert into Payment_CustInfo

                SqlHelper.ExecuteNonQuery(ConfigurationManager.AppSettings["SQLConnectionString"],
                        "Payment_Insert_CustInfo",
                        Convert.ToInt32(ID),
                        ipnTx.CustomerInfo.Address1,
                        ipnTx.CustomerInfo.Address2,
                        ipnTx.CustomerInfo.AddressName,
                        ipnTx.CustomerInfo.AddressStatus,
                        ipnTx.CustomerInfo.BusinessName,
                        ipnTx.CustomerInfo.City,
                        ipnTx.CustomerInfo.Country,
                        ipnTx.CustomerInfo.DayPhoneA,
                        ipnTx.CustomerInfo.DayPhoneB,
                        ipnTx.CustomerInfo.DayPhoneC,
                        ipnTx.CustomerInfo.Email,
                        ipnTx.CustomerInfo.FirstName,
                        ipnTx.CustomerInfo.LastName,
                        ipnTx.CustomerInfo.NightPhoneA,
                        ipnTx.CustomerInfo.NightPhoneB,
                        ipnTx.CustomerInfo.NightPhoneC,
                        ipnTx.CustomerInfo.PayerID,
                        ipnTx.CustomerInfo.PayerStatus,
                        ipnTx.CustomerInfo.State,
                        ipnTx.CustomerInfo.Zip);


                #endregion
                Logger.Log("IpnService : Insert Into Payment_CustInfo: Completed");
                Logger.Log("IpnService : Insert Into Payment_ShoppingItems: Beginning");
                #region Insert Payment Shopping Items
                PayPal.Web.Controls.ShoppingItemCollection shoppingItemCollection = new PayPal.Web.Controls.ShoppingItemCollection();
                shoppingItemCollection = ipnTx.Items;
                for (int count = 0; count < shoppingItemCollection.Count; count++)
                {

                    SqlHelper.ExecuteNonQuery(ConfigurationManager.AppSettings["SQLConnectionString"],
                        "Payment_Insert_Shopping_Items",
                        Convert.ToInt32(ID),
                        shoppingItemCollection[count].ItemName,
                        shoppingItemCollection[count].ItemNumber,
                        shoppingItemCollection[count].Option1FieldName,
                        shoppingItemCollection[count].Option1Values,
                        shoppingItemCollection[count].Option2FieldName,
                        shoppingItemCollection[count].Option2Values);

                }
                #endregion
                Logger.Log("IpnService : Insert Into Payment_ShoppingItems: Completed");


            }
            catch (Exception ex)
            {
                SendMail mail = new SendMail();
                string body;
                string to;
                string subject;

                body = "Customer Name: " + ipnTx.CustomerInfo.FirstName + " " + ipnTx.CustomerInfo.LastName + "<br";
                body += "Customer Email: " + ipnTx.CustomerInfo.Email + "<br>";
                body += "Transaction ID: " + ipnTx.Invoice + "<br>";
                body += "Error Message: " + ex.Message + "<br>";

                Logger.Log("IpnService : Exception : " + body);

                to = ConfigurationManager.AppSettings["AdminEmail"];

                subject = "An error occured while entering the Payment transaction information.";

                mail.Send(subject, body, to);

                return false;

            }

            return true;




        }





    }
}
