using System;
using System.Data;
using System.Configuration;
using System.Diagnostics;

namespace SSK.Server
{

    public class Logger
    {
        private static bool bSetup = false;

        public bool AlreadySetup
        {
            get
            {
                return bSetup;
            }
        }

        public Logger(string path, string fileName)
        {
            if (!bSetup)
            {
                try
                {
                    string logPath = path;

                    bool log = false;

                    log = Convert.ToBoolean(ConfigurationManager.AppSettings["loggingEnabled"]);

                    if (log)
                    {
                        string fullPath;

                        if (logPath != "")
                        {
                            fullPath = logPath + "\\" + fileName;
                        }
                        else
                        {
                            fullPath = System.Web.HttpContext.Current.Request.PhysicalApplicationPath
                                 + fileName;
                        }

                        // Setup logging listener
                        Trace.Listeners.Add(new TextWriterTraceListener(fullPath));
                        Trace.AutoFlush = true;
                    }
                }

                catch (System.Exception ex)
                {

                    // Do nothing, logging will not be enabled

                }

                bSetup = true;
            }

        }

        public static void Log(string s)
        {

            Trace.WriteLine(DateTime.Now.ToString() + " : " + s);

        }
    }
    
}