using System;
using System.Configuration;
using System.Data.SqlClient;
using Microsoft.ApplicationBlocks.Data;
using System.Net.Mail;


namespace SSK.Server
{
    /// <summary>
    /// Summary description for SendMail.
    /// </summary>
    public class SendMail
    {
        //constructor
        public SendMail() {}

        /// <summary>
        /// Send an email to the user with their license information
        /// </summary>
        /// <param name="invoice">The invoice for the transaction</param>
        /// <param name="authLicense">The product key generated by the system.</param>
        public void SendMailApprovedLicense(string invoice, string authLicense)
        {

            SqlDataReader reader = SqlHelper.ExecuteReader(ConfigurationManager.AppSettings["SQLConnectionString"],
                                "SendMailApprovedLicense", invoice);

            if (reader.HasRows)
            {
                reader.Read();

                string body;
                string to = (string)reader["Email"];
                string subject = "Your product has been activated.";

                body = "<table width=\"500\"><tr><td>";
                body += "Dear " + (string)reader["Firstname"] + ",<br><br><br>";
                body += "Thank you for activating your product.  Please make a note of the following information ";
                body += "for future reference:<br><br>";
                body += "</td></tr>";
                body += "<tr><td width=\"500\">";
                body += "Product Key: " + invoice + " ";
                body += "<br><br>"; 
                body += "</td></tr>";
                body += "<tr><td>";
                body += "Thank you,<Br>";
                body += ConfigurationManager.AppSettings["FromName"] + "<br><br>";
                body += ConfigurationManager.AppSettings["FromEmail"];
                body += "</td></tr>";
                body += "</table>";

                try
                {
                    Send(subject, body, to);
                }
                catch
                {
                    //fail gracefully if the mail doesn't send
                }
            }

        }



        public void Send(string subject, string body, string to)
        {
            SmtpClient          mailClient = new SmtpClient( ConfigurationManager.AppSettings["SMTP"] );
            MailAddress         addressFrom = new MailAddress( ConfigurationManager.AppSettings["FromEmail"] );
            MailAddress         addressTo = new MailAddress( to );
            
        }


    }
}
