using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Diagnostics;
using SSK.Server;


namespace PayPal.IPN
{
    public partial class TestPaymentServer_aspx : System.Web.UI.Page
    {
        
        private Logger testPaymentServerlogger = new Logger(ConfigurationSettings.AppSettings["loggingPath"], "SharewareServiceLog.txt");

        void Page_Load(object sender, EventArgs e)
        {
            Logger.Log("TestPaymentServer_aspx : Beginning Page Load");
            // Grab the invoiceID GUID that is sent from the client
            string invoiceID = Request.QueryString["invoice"];
            string developerID = Request.QueryString["custom"];
            
            if (invoiceID == null)
            {
                Response.Write("Your application needs to provide an invoiceID " +
                    "in the QueryString!");
                Logger.Log("TestPaymentServer_aspx : Your application needs to provide an invoiceID " +
                    "in the QueryString!");
                
                lblDevID.Visible = false;
                lblInvoiceID.Visible = false;
                lblMessage.Visible = false;
                lblCustEmail.Visible = false;
                lblCustFirstName.Visible = false;
                lblReceiverEmail.Visible = false;

                txtDevID.Visible = false;
                txtInvoiceID.Visible = false;
                txtDevID.Visible = false;
                txtCustEmail.Visible = false;
                txtCustFirstName.Visible = false;
                txtReceiverEmail.Visible = false;
                
                btnPay.Visible = false;
                
            }
            else
            {
                txtInvoiceID.Text = invoiceID;
                txtCustEmail.Text = ConfigurationSettings.AppSettings["defaultCustomerEmail"];
                txtCustFirstName.Text = ConfigurationSettings.AppSettings["defaultCustomerFirstName"];
                txtReceiverEmail.Text = Request.QueryString["business"];
                txtDevID.Text = developerID;
            }
            Logger.Log("TestPaymentServer_aspx : Completed Page Load");
        }
        #region Web Form Designer generated code

        override protected void OnInit(EventArgs e)
        {
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit(e);
        }

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.btnPay.Click += new System.EventHandler(this.btnPay_Click);
        }
        #endregion

        public void btnPay_Click(object sender, System.EventArgs e)
        {

            Logger.Log("TestPaymentServer_aspx : btnPay_Click: Beginning");
            // Create the IpnTransaction
            IpnTransaction ipn = new IpnTransaction();

            ipn.RawIPN = Request.Form.ToString();
            ipn.Invoice = txtInvoiceID.Text;
            ipn.ReceiverEmail = txtReceiverEmail.Text;
            ipn.McCurrency = PayPal.Web.Controls.CurrencyCode.USD;
            ipn.PaymentType = PaymentType.Instant;
            ipn.PaymentStatus = PaymentStatus.Completed;
            ipn.McFee = float.Parse(Request.QueryString["amount"]);
            ipn.McGross = float.Parse(Request.QueryString["amount"]);
            ipn.Business = Request.QueryString["business"];
            ipn.Custom = Request.QueryString["custom"];
            
            IpnCustomerInfo ci = new IpnCustomerInfo();
            ci.Email = txtCustEmail.Text;
            ci.FirstName = txtCustFirstName.Text;

            ipn.CustomerInfo = ci;

            // Make the request to the web service
            IpnService service = new IpnService();
            Logger.Log("TestPaymentServer_aspx : btnPay_Click : service.ProcessTransaction : Beginning");
            service.ProcessTransaction(ipn);
            lblMessage.Text = "Test payment successfully submitted.  Please return to the application to " +
                "check the activation status.";
            Logger.Log("TestPaymentServer_aspx : btnPay_Click : service.ProcessTransaction : Completed");
            Logger.Log("TestPaymentServer_aspx : btnPay_Click : Completed");
        }

    }
    
    
}